/*
 *	main.c
 *
 *	AY Player
 *
 *	* Tue Nov 25 06:00:00 JST 2003 Naoyuki Sawa
 *	- 1st [XB
 *	* Wed Nov 26 12:30:00 JST 2003 Naoyuki Sawa
 *	- Z80 CPU       ... ߂̈ꕔɑΉ܂B
 *	- AY-3-891x PSG ... Gx[vɑΉ܂B(Ɖ?)
 */
#include "app.h"

//#define SPEED_TEST

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _AYINFO {
	char fname[MAXFILENAME + 1];		/* t@C */
	int size;				/* t@CTCY */
} AYINFO;

#define MAX_DISP	13			/* Sɕ\łt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int draw;				/* ĕ`tO */
int now;				/* O[o^C} */
int joy;				/* pbh */

AYINFO ay_info[MAXDIR];		/* AYt@CXg */
int ay_count;				/* AYt@C̐   */

int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */

const AYHEADER* ay;			/* tAYt@C(tbVڎQ) */
int track;				/* -1:t@CI[h/0`:݂̑IgbNԍ */
int playing;				/* 0:~/1:t */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void err_disp(const char* fmt, ...);
void app_init();
void app_exit();
void schedule();
void file_sel();
void track_sel();
void disp();

/****************************************************************************
 *	main
 ****************************************************************************/

#ifndef SPEED_TEST
int
main()
{
	/* B */
	app_init();

	/* C[vB */
	track = -1;
	file_sel();

	return 0;
}
#endif /*SPEED_TEST*/

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static int
ay_info_compare(const void* _a, const void* _b)
{
	AYINFO* a = (AYINFO*)_a;
	AYINFO* b = (AYINFO*)_b;
	return strcmp(a->fname, b->fname);
}

void
app_init()
{
	int retval, len;
	FILEINFO fi;
	AYINFO* mi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(10/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* AYt@CT܂B */
	memset(ay_info, 0, sizeof ay_info);
	ay_count = 0;
	mi = &ay_info[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(ay_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".ay"łȂ΁A΂܂B */
		len = strlen(fi.filename);
		if(len < 3) continue;
		if(strcasecmp(&fi.filename[len - 3], ".ay") != 0) continue;
		/* t@CƃTCYi[܂B */
		if(len > MAXFILENAME) DIE();
		memcpy(mi->fname, fi.filename, len);
		mi->size = fi.length;
		ay_count++;
		mi++;
	}
	pceFileFindClose(&fi);
	if(ay_count == 0) {
		err_disp("AYt@C܂");
		exit(0);
	}

	/* t@CɃ\[gB */
	qsort(ay_info, ay_count, sizeof(AYINFO), ay_info_compare);

	/* S48MHz[hB */
	turbo(1);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
	if(now % SEC(1) == 0) {
		draw = 1;
	}

	/* ʍXVB */
	if(draw) {
		pceLCDTrans();
		draw = 0;
	}

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* O[o^C}XVB */
	now++;

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT
}

/****************************************************************************
 *	file_sel
 ****************************************************************************/

void
file_sel()
{
	AYINFO* mi;

	disp(); /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(joy & TRG_UP && cursel > 0           ) cursel--;
		if(joy & TRG_DN && cursel < ay_count - 1) cursel++;
		if(joy & TRG_LF) {
			cursel -= MAX_DISP;
			if(cursel < 0) cursel = 0;
		}
		if(joy & TRG_RI) {
			cursel += MAX_DISP;
			if(cursel > ay_count - 1) cursel = ay_count - 1;
		}
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĐJnH */
		if(joy & TRG_A) {
			ay_stop(); /* t@C񒆂̃mCY}邽߁AIɒ~ */
			mi = &ay_info[cursel];
			ay = (const AYHEADER*)file_defrag(mi->fname, NULL);
			if(ay) {
				track_sel();
			} else {
				err_disp("̧ق͍Đł܂");
				/* p */
			}
		}

		/* ĕ`B */
		disp();
	}
}

/****************************************************************************
 *	track_sel
 ****************************************************************************/

void
track_sel()
{
	track = ay->FirstSong;

	disp(); /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* gbNIύXH */
		if(joy & TRG_LF && track > 0             ) track--;
		if(joy & TRG_RI && track < ay->NumOfSongs) track++;	/* NumOfSongs(Ȑ-1)ł!! */
		if(joy & TRG_UP) {
			track -= 10;
			if(track < 0) track = 0;
		}
		if(joy & TRG_DN) {
			track += 10;
			if(track > ay->NumOfSongs) track = ay->NumOfSongs;	/* NumOfSongs(Ȑ-1)ł!! */
		}

		/* ĐJnH */
		if(joy & TRG_A) {
			playing = 1;
			if(ay_play(ay, track) != 0) {
				err_disp("̧ق͍Đł܂");
				break;
			}
		}

		/* ĐIort@CXg֔H */
		if(joy & TRG_B) {
			if(playing) {
				playing = 0;
				ay_stop();
			} else {
				break;
			}
		}

		/* ĕ`B */
		disp();
	}

	track = -1;
}

/****************************************************************************
 *	disp
 ****************************************************************************/

void
disp()
{
	int i, x, y, c, i_ay;
	AYINFO* mi;
	AYSONGSTRUCTURE* ss;

	/* ʓ]B */
	draw = 1;

	/*----- t@CI[h -----*/

	/* t@CXg\B */
	memset(vbuff, 0, sizeof vbuff);
	mi = &ay_info[curtop];
	y = 8;
	for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
		i_ay = curtop + i;
		if(i_ay > ay_count - 1) break;
		if(i_ay == cursel) {
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
			c = 0;
		} else {
			c = 2;
		}
		render_string(&render, 4 + 4 *  1, y, mi->fname, 0x82, c);
		render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", mi->size);
		mi++;
		y += 6;
	}

	/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
	render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
	render_string(&render, 0, 1,
	//       0123456789012345678901234567890123
		"=========== AY Player ===========",
		0x82, 0);

	/* t@CI[hȂA܂ŁB */
	if(track < 0) return;

	/*----- gbNI[h -----*/

	if(memcmp(ay, "ZXAYEMUL", 8) != 0) return; /* Ô߁c */
	ss = (AYSONGSTRUCTURE*)AYPTR(ay->PSongsStructure) + track;

	x = 0;
	y = 8 + 6 * 2;
	render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 * 9 + 1, 3);
	render_string(&render, x + 4, y, "Author:"           , 0x82, 0); y += 6;
	render_string(&render, x + 8, y, AYPTR(ay->PAuthor)  , 0x82, 1); y += 6;
	render_string(&render, x + 4, y, "Misc:"             , 0x82, 0); y += 6;
	render_string(&render, x + 8, y, AYPTR(ay->PMisc)    , 0x82, 1); y += 6;
	render_string(&render, x + 4, y, "Track:"            , 0x82, 0); y += 6;
	render_string(&render, x + 4, y, "Song Name:"        , 0x82, 0); y += 6;
	render_string(&render, x + 8, y, AYPTR(ss->PSongName), 0x82, 1); y += 6;
	render_printf(&render, x +  8, y, 0x82, 1, "%3d/%3d", track + 1, ay->NumOfSongs + 1); y += 6;	/* NumOfSongs(Ȑ-1)ł!! */
	if(playing) {
		render_string(&render, x + 4, y, "PLAYING...       A:PLAY/B:STOP", 0x82, 0); y += 6;
	} else {
		render_string(&render, x + 4, y, "                 A:PLAY/B:QUIT", 0x82, 0); y += 6;
	}
}

/****************************************************************************
 *	SPEED_TEST
 ****************************************************************************/

#ifdef SPEED_TEST
int
main()
{
	static AYDRIVER ay;
	static short wbuff[AYBUFLEN];

	const void* romp;
	int i, T0, T1;

	app_init();

	romp = file_defrag("dragonsp.ay", NULL);
	if(!romp) DIE();
	if(ay_init(&ay, romp, 0) != 0) DIE();
	T0 = pceTimerGetCount();
	for(i = 0; i < SPEAKER_FREQUENCY / AYBUFLEN * 1; i++) {
		ay_stream_callback(wbuff, (int)&ay);
	}
	T1 = pceTimerGetCount();
	pceFontSetPos(0, 0);
	pceFontPrintf("%d\n", T1 - T0);
	for(;;) {
		schedule();
	}

	return 0;
}
#endif /*SPEED_TEST*/
